/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-react-core/ES2015/Brush";
import { DependencyProperty } from "igniteui-react-core/ES2015/DependencyProperty";
import { Series } from "./Series";
import { Thickness } from "igniteui-react-core/ES2015/Thickness";
import { Visibility_$type } from "igniteui-react-core/ES2015/Visibility";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-react-core/ES2015/Dictionary$2";
import { Pool$1 } from "igniteui-react-core/ES2015/Pool$1";
import { AxisAnnotation } from "./AxisAnnotation";
import { Type, Number_$type, enumGetBox, fromEnum, Point_$type, markType, runOn } from "igniteui-react-core/ES2015/type";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { Tuple$2 } from "igniteui-react-core/ES2015/Tuple$2";
import { Path } from "igniteui-react-core/ES2015/Path";
import { PathGeometry } from "igniteui-react-core/ES2015/PathGeometry";
import { PathFigure } from "igniteui-react-core/ES2015/PathFigure";
import { LineSegment } from "igniteui-react-core/ES2015/LineSegment";
import { PropertyMetadata } from "igniteui-react-core/ES2015/PropertyMetadata";
import { isNaN_ } from "igniteui-react-core/ES2015/number";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { TranslateTransform } from "igniteui-react-core/ES2015/TranslateTransform";
import { LineGeometry } from "igniteui-react-core/ES2015/LineGeometry";
import { BrushUtil } from "igniteui-react-core/ES2015/BrushUtil";
export class CrosshairLayer extends AnnotationLayer {
    constructor() {
        super();
        this.xAxisAnnotationFormatLabel = null;
        this.yAxisAnnotationFormatLabel = null;
        this.m3 = null;
        this.m2 = null;
        let a = new CrosshairLayerFrame();
        let b = new CrosshairLayerFrame();
        let c = new CrosshairLayerFrame();
        let d = this.fe / 1000;
        this.lt = a;
        this.ls = b;
        this.lu = c;
        this.ab = CrosshairLayer.$;
    }
    bf() {
        return new CrosshairLayerView(this);
    }
    il(a) {
        super.il(a);
        this.mv = a;
    }
    mx() {
        return this.xAxisAnnotationFormatLabel != null;
    }
    my() {
        return this.yAxisAnnotationFormatLabel != null;
    }
    get o7() {
        return new Thickness(1, this.m5, this.m7, this.m6, this.m4);
    }
    get o8() {
        return new Thickness(1, this.na, this.nc, this.nb, this.m9);
    }
    ma(a, b) {
        if (this.mw == null || this.mw == a) {
            if (!this.aq.c) {
                this.i4(b);
            }
        }
    }
    mc(a, b) {
        super.mc(a, b);
        let c = a;
        let d = this.m1;
        let e = this.m0;
        c.ad.clear();
        c.ae.clear();
        c.ac.clear();
        c.af.clear();
        AxisAnnotationFrameManager.b(c);
        if (this.lx(this.mw)) {
            this.n7(this.mw, c, d, e);
        }
        else {
            for (let f of fromEnum(this.bs.series)) {
                if (this.lx(f)) {
                    this.n7(f, c, d, e);
                }
            }
        }
    }
    lx(a) {
        if (!super.lx(a)) {
            return false;
        }
        let b = this.l5(a);
        if (!b.c) {
            return false;
        }
        return true;
    }
    ie() {
        super.ie();
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.ca()) {
            this.n8(this.lu, false);
        }
        else {
            this.n8(this.ls, false);
        }
    }
    n7(a, b, c, d) {
        let e = this.l5(a);
        if (!e.c) {
            return;
        }
        let f = e.d;
        f = a.lc(f, c, d);
        let g = this.ku;
        if (g == null) {
            g = this.kw;
        }
        if (g == null) {
            g = a.ku;
            if (g != null) {
                g = this.mv.b8(g);
            }
        }
        let h = g;
        let i = g;
        if (this.oz != null) {
            h = this.oz;
        }
        if (this.o0 != null) {
            i = this.o0;
        }
        b.ac.add(h);
        b.af.add(i);
        b.ad.add(f.y);
        b.ae.add(f.x);
        if (this.mz) {
            AxisAnnotationFrameManager.c(b, f, a, this.bs, this.getEffectiveViewport(), g, this.o1, this.o3, this.o2, this.o7, this.m8, this.o4, this.o6, this.o5, this.o8, this.nd, this.pa == 0, this.o9 == 0);
        }
    }
    n8(a, b) {
        let c = false;
        if (this.m2 == null) {
            c = true;
            this.m3 = new List$1(Axis.$, 0);
            this.m2 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.m2, this.m3, b, this.ne, this.nf, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
    }
    n6(a, b, c, d, e) {
        let f = a.item(b);
        b++;
        if (e) {
            f._stroke = d.af._inner[c];
            f._fill = d.af._inner[c];
        }
        else {
            f._stroke = d.ac._inner[c];
            f._fill = d.ac._inner[c];
        }
        f.ac = this.eu;
        f.ai = this.k2;
        f.ad = this.k3;
        return new Tuple$2(Path.$, Number_$type, f, b);
    }
    mf(a, b) {
        super.mf(a, b);
        let c = this.mv.b2;
        let d = a;
        let e = d.ad.count;
        let f = 0;
        let g = b.br.left;
        let h = b.br.right;
        let i = b.br.top;
        let j = b.br.bottom;
        let k = this.pa == 0;
        let l = this.o9 == 0;
        for (let m = 0; m < e; m++) {
            let n = Math.floor(d.ad._inner[m]);
            let o = Math.floor(d.ae._inner[m]);
            let p = null;
            if (k) {
                if (isNaN_(n)) {
                    continue;
                }
                let q = this.n6(c, f, m, d, true);
                p = q.c;
                f = q.d;
                let r = new PathGeometry();
                let s = new PathFigure();
                s._startPoint = { $type: Point_$type, x: o, y: i };
                let t = new LineSegment(1);
                t.c = { $type: Point_$type, x: o, y: j };
                s._segments.add(t);
                r.b.add(s);
                p.aj = r;
            }
            if (l) {
                if (isNaN_(n)) {
                    continue;
                }
                let u = this.n6(c, f, m, d, false);
                p = u.c;
                f = u.d;
                let v = new PathGeometry();
                let w = new PathFigure();
                w._startPoint = { $type: Point_$type, x: g, y: n };
                let x = new LineSegment(1);
                x.c = { $type: Point_$type, x: h, y: n };
                w._segments.add(x);
                v.b.add(w);
                p.aj = v;
            }
        }
        c.count = f;
        if (this.ca()) {
            this.n8(this.lu, true);
        }
        else {
            this.n8(this.ls, false);
        }
    }
    c6() {
        return true;
    }
    ir(a, b, c, d) {
        super.ir(a, b, c, d);
        switch (b) {
            case CrosshairLayer.$$p[1]:
                this.i4(true);
                break;
            case CrosshairLayer.$$p[7]:
                this.i4(true);
                break;
            case CrosshairLayer.$$p[4]:
                this.i4(true);
                break;
            case CrosshairLayer.$$p[2]:
            case CrosshairLayer.$$p[8]:
            case CrosshairLayer.$$p[10]:
            case CrosshairLayer.$$p[12]:
            case CrosshairLayer.$$p[14]:
            case CrosshairLayer.$$p[13]:
            case CrosshairLayer.$$p[11]:
            case CrosshairLayer.$$p[15]:
            case CrosshairLayer.$$p[16]:
            case CrosshairLayer.$$p[17]:
            case CrosshairLayer.$$p[19]:
            case CrosshairLayer.$$p[21]:
            case CrosshairLayer.$$p[23]:
            case CrosshairLayer.$$p[22]:
            case CrosshairLayer.$$p[20]:
            case CrosshairLayer.$$p[24]:
            case CrosshairLayer.$$p[25]:
            case CrosshairLayer.$$p[0]:
            case CrosshairLayer.$$p[6]:
            case CrosshairLayer.$$p[5]:
                this.i4(true);
                break;
        }
    }
}
CrosshairLayer.$t = markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
Type.dep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:oz:n9', [Brush.$, null], 'HorizontalLineVisibility:o9:oa', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:mz:ob', [0, false], 'SkipUnknownValues:m0:oc', [0, true], 'TargetSeries:mw:od', [Series.$, null], 'UseInterpolation:m1:oe', [0, true], 'VerticalLineStroke:o0:of', [Brush.$, null], 'VerticalLineVisibility:pa:og', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackground:o1:oh', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:ne:oi', [1, -1], 'XAxisAnnotationOutline:o2:oj', [Brush.$, null], 'XAxisAnnotationPaddingBottom:m4:ok', [1, NaN], 'XAxisAnnotationPaddingLeft:m5:ol', [1, NaN], 'XAxisAnnotationPaddingRight:m6:om', [1, NaN], 'XAxisAnnotationPaddingTop:m7:on', [1, NaN], 'XAxisAnnotationStrokeThickness:m8:oo', [1, NaN], 'XAxisAnnotationTextColor:o3:op', [Brush.$, null], 'YAxisAnnotationBackground:o4:oq', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:nf:or', [1, -1], 'YAxisAnnotationOutline:o5:os', [Brush.$, null], 'YAxisAnnotationPaddingBottom:m9:ot', [1, NaN], 'YAxisAnnotationPaddingLeft:na:ou', [1, NaN], 'YAxisAnnotationPaddingRight:nb:ov', [1, NaN], 'YAxisAnnotationPaddingTop:nc:ow', [1, NaN], 'YAxisAnnotationStrokeThickness:nd:ox', [1, NaN], 'YAxisAnnotationTextColor:o6:oy', [Brush.$, null]]);
export class CrosshairLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b2 = null;
        this.b3 = null;
        this.b1 = a;
        this.b3 = new List$1(Path.$, 0);
    }
    ap() {
        super.ap();
        this.b2 = ((() => {
            let $ret = new Pool$1(Path.$);
            $ret.create = runOn(this, this.b9);
            $ret.activate = runOn(this, this.b4);
            $ret.disactivate = runOn(this, this.b6);
            $ret.destroy = runOn(this, this.b5);
            return $ret;
        })());
    }
    b9() {
        let a = new Path();
        a.j = new TranslateTransform();
        this.b3.add(a);
        return a;
    }
    b4(a) {
        a._visibility = 0;
    }
    b6(a) {
        a._visibility = 1;
    }
    b5(a) {
        this.b3.remove(a);
    }
    b7(a, b, c, d) {
        if (a.aj == null || a.aj.b.x != d || a.aj.c.x != c) {
            let e = ((() => {
                let $ret = new LineGeometry();
                $ret.c = { $type: Point_$type, x: c, y: b };
                $ret.b = { $type: Point_$type, x: d, y: b };
                return $ret;
            })());
            a.aj = e;
        }
    }
    b8(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.h(a, 0.1);
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d && !b) {
            for (let c = 0; c < this.b3.count; c++) {
                let d = this.b3._inner[c];
                if (d._visibility == 0) {
                    a.s(d);
                }
            }
        }
    }
    ai(a) {
        super.ai(a);
        for (let b = 0; b < this.b3.count; b++) {
            this.e.a2.exportPathData(a, this.b3._inner[b], "crosshairLine", ["Main", "Crosshair"]);
        }
    }
}
CrosshairLayerView.$t = markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
